from sqlalchemy import *
from migrate import *
import migrate.changeset
from dictionaries.versions import views_helper
import re

def getKbkeyTables(meta):
    kbkey1 = Table('kbkey1', meta, autoload=True)
    kbkey2 = Table('kbkey2', meta, autoload=True)
    return [kbkey1, kbkey2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Upgrade operations go here. Don't create your own engine; use the engine
    # named 'migrate_engine' imported from migrate.
    for tbl in getKbkeyTables(meta):
        tbl.c.keycode.alter(autoincrement=False, nullable=False, default=0)
        context = Column('context', String(100), nullable=False, default='')
        context.create(tbl)
        cons = migrate.changeset.constraint.PrimaryKeyConstraint(tbl.c.keycode, name = 'pk_%s' % tbl.name)
        cons.drop()
        tbl.c.context.alter(primary_key=True)
        cons2 = migrate.changeset.constraint.PrimaryKeyConstraint(tbl.c.keycode, tbl.c.context, name = 'pk_%s' % tbl.name)
        cons2.create()
    views_helper.update_dic_view(migrate_engine, 'kbkey')

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    # Operations to reverse the above upgrade go here.    
    conn = migrate_engine.connect()
    tblname = views_helper.get_table_name(migrate_engine,'kbkey')

    conn.execute("delete from kbkey1 where context != '';")
    conn.execute("delete from kbkey2 where context != '';")
    
    for tbl in getKbkeyTables(meta):
        tbl.c.context.drop()
    views_helper.update_dic_view(migrate_engine, 'kbkey',tblname)
