from sqlalchemy import *
from migrate import *
from dictionaries.versions import views_helper

def getAspectvaluesetTables(meta):
    aspectvalueset1 = Table('aspectvalueset1', meta, autoload=True)
    aspectvalueset2 = Table('aspectvalueset2', meta, autoload=True)
    return [aspectvalueset1, aspectvalueset2]

def upgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    for tbl in getAspectvaluesetTables(meta):
        remaindate = Column('remaindate', DateTime, nullable=True)
        if not 'remaindate' in tbl.columns:
            remaindate.create(tbl)

        packingprice = Column('packingprice', Numeric (15,2), nullable=True)
        if not 'packingprice' in tbl.columns:
            packingprice.create(tbl)

    views_helper.update_dic_view(migrate_engine, 'aspectvalueset')

def downgrade(migrate_engine):
    meta = MetaData(bind = migrate_engine)
    aspectvalueset = views_helper.get_table_name(migrate_engine,'aspectvalueset')
    for tbl in getAspectvaluesetTables(meta):
        if 'remaindate' in tbl.columns:
            tbl.c.remaindate.drop()
        if 'packingprice' in tbl.columns:
            tbl.c.packingprice.drop()
    views_helper.update_dic_view(migrate_engine, 'aspectvalueset', aspectvalueset)
