from sqlalchemy import Table, MetaData, Index
from dictionaries.versions import views_helper

def getBarcodes(meta):
    barcodes1 = Table('barcodes1', meta, autoload=True)
    barcodes2 = Table('barcodes2', meta, autoload=True)
    return [barcodes1,barcodes2]

def upgrade(migrate_engine):

    meta = MetaData(bind = migrate_engine)

    for tbl in getBarcodes(meta):
        if 'barcodesidxbarcode' in [ind.name for ind in tbl.indexes]:
            Index('barcodesidxbarcode', tbl.c.barcode).drop()
        if 'barcodesidxcode' in [ind.name for ind in tbl.indexes]:
            Index('barcodesidxcode', tbl.c.barcode).drop()
        Index('barcodesidxcode', tbl.c.code).create()
        if 'barcodesidxprice' not in [ind.name for ind in tbl.indexes]:
            Index('barcodesidxprice', tbl.c.price).create()

    views_helper.update_dic_view(migrate_engine, 'barcodes')

def downgrade(migrate_engine):

    meta = MetaData(bind = migrate_engine)
    
    for tbl in getBarcodes(meta):
        if 'barcodesidxcode' in [ind.name for ind in tbl.indexes]:
            Index('barcodesidxcode', tbl.c.code).drop()
        Index('barcodesidxcode', tbl.c.barcode, unique=True).create()
        if 'barcodesidxprice' in [ind.name for ind in tbl.indexes]:
            Index('barcodesidxprice', tbl.c.price).drop()

    views_helper.update_dic_view(migrate_engine, 'barcodes')
