from sqlalchemy import *
from dictionaries.versions import views_helper
from migrate import *
import migrate.changeset

def upgrade(migrate_engine):

    meta = MetaData(bind = migrate_engine)

    for tbl in views_helper.getTables(meta, 'tprices'):
        if views_helper.isInnoDB(migrate_engine, tbl.name):
            continue

        tbl.c.tindex.alter(autoincrement=False)
        pk = constraint.PrimaryKeyConstraint('tindex','bcode', table=tbl)
        pk.drop()
        pk = constraint.PrimaryKeyConstraint('bcode','tindex', table=tbl)
        pk.create()
        tbl.c.tindex.alter(autoincrement=True)

    for tbl in views_helper.getTables(meta,'tprices'):
        if 'tpricesidxdocumentid' in [ind.name for ind in tbl.indexes]:
            Index('tpricesidxdocumentid', tbl.c.tindex, tbl.c.bcode, tbl.c.documentid, unique=True).drop()

    views_helper.update_dic_view(migrate_engine, 'tprices')

def downgrade(migrate_engine):

    meta = MetaData(bind = migrate_engine)    
    for tbl in views_helper.getTables(meta,'tprices'):
        if 'tpricesidxdocumentid' not in [ind.name for ind in tbl.indexes]:
            Index('tpricesidxdocumentid', tbl.c.tindex, tbl.c.bcode, tbl.c.documentid, unique=True).create()
        tbl.c.tindex.alter(autoincrement=False)
        pk = constraint.PrimaryKeyConstraint('bcode','tindex', table=tbl)
        pk.drop()
        pk = constraint.PrimaryKeyConstraint('tindex','bcode', table=tbl)
        pk.create()
        tbl.c.tindex.alter(autoincrement=True)

    views_helper.update_dic_view(migrate_engine, 'tprices')
