from sqlalchemy import *
from migrate import *

def getTable(meta):
    return Table('document', meta, autoload=True)

def upgrade(migrate_engine):
    # Upgrade operations go here. Don't create your own engine; bind migrate_engine
    # to your metadata
    meta = MetaData(bind = migrate_engine)
    
    document = getTable(meta)
    url_egais=Column('url_egais', Text, nullable=True)
    digital_signature_egais=Column('digital_signature_egais', Text, nullable=True)
    
    if 'url_egais' not in document.columns:
        url_egais.create(document)
    if 'digital_signature_egais' not in document.columns:
        digital_signature_egais.create(document)

def downgrade(migrate_engine):
    # Operations to reverse the above upgrade go here.
    meta = MetaData(bind = migrate_engine)
    
    document = getTable(meta)
    if 'url_egais' in document.columns:
        document.c.url_egais.drop()
    if 'digital_signature_egais' in document.columns:
        document.c.digital_signature_egais.drop()
