from sqlalchemy import *
from migrate import *
from documents.versions import dump

def getTables(meta):
    return Table('carditem', meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)
    tbl = getTables(meta)
    if not 'counters' in tbl.columns:
        Column('counters', Text(), nullable=True).create(tbl)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTables(meta)
    if 'counters' in tbl.columns:
        Column('counters', String(200), nullable=True).drop(tbl)
