from sqlalchemy import *
from migrate import *

column_name = 'operationinfo'

def getTables(meta):
    return Table('carditem', meta, autoload=True)

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTables(meta)
    if not column_name in tbl.columns:
        Column(column_name, Text(), nullable=True).create(tbl)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    tbl = getTables(meta)
    if column_name in tbl.columns:
        Column(column_name, Text(), nullable=True).drop(tbl)