from sqlalchemy import *
from migrate import *
from documents.versions import dump

priceDocTypeColumn = 'pricedoctype'
priceDocTypeColumnType = Integer

def getTables(meta):
    goodsitem = Table('goodsitem', meta, autoload = True)
    stornogoodsitem = Table('stornogoodsitem', meta, autoload = True)
    return [goodsitem, stornogoodsitem]

def upgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)
    dump.store(migrate_engine)

    for table in getTables(meta):
        if not priceDocTypeColumn in table.columns:
            Column(priceDocTypeColumn, priceDocTypeColumnType, nullable=True).create(table)

def downgrade(migrate_engine):
    meta = MetaData(bind=migrate_engine)

    for table in getTables(meta):
        if priceDocTypeColumn in table.columns:
            Column(priceDocTypeColumn, priceDocTypeColumnType, nullable=True).drop(table)

