# -*- coding: utf-8 -*-
import pymysql
from artix.database.info import DBInfo

dbInfo = DBInfo()
db = pymysql.connect(host=dbInfo.host, port=dbInfo.port, user=dbInfo.user, password=dbInfo.password, db='dictionaries')
db.set_character_set('utf8')
cursor = db.cursor()

listcommand = [
        ('COMMAND_ADDMONEYPOSITION', 'Добавление денежной позиции (внесение/изъятие)'),
        ('COMMAND_ADDPAYMENTPOSITION','Добавление оплаты в чеке'),
        ('COMMAND_MACRO','Макрос'),
        ('COMMAND_VALUT_OPERATIONEXT','Внешняя операция валюты'),
        ('COMMAND_INVENTORY','Инвентаризация'),
        ('COMMAND_INVENTORYCLOSE','Закрытие инвентаризации'),
        ('COMMAND_BUTTON','Скидка по кнопке'),
        ('COMMAND_DOCOPEN','Открытие документа'),
        ('COMMAND_DOCCANCEL','Аннулирование документа'),
        ('COMMAND_BCODELIST','Выбор из списка штрих-кодов'),
        ('COMMAND_NAMELIST','Выбор из списка наименований'),
        ('COMMAND_PRICELIST','Выбор из списка штрих-кодов'),
        ('COMMAND_ARTICULLIST','Выбор из списка по артикулу'),
        ('COMMAND_BCODETESTBYNAME','Просмотр информации о товаре (подбор по наименованию)'),
        ('COMMAND_RESET','Сброс'),
        ('COMMAND_SUBTOTAL','Подитог'),
        ('COMMAND_DISCOUNT','Запрос ввода карты'),
        ('COMMAND_UNDOCARD','Отмена карты'),
        ('COMMAND_CHECK','Чек'),
        ('COMMAND_CODELIST','Выбор из списка кодов'),
        ('COMMAND_BACKBYSALE','Возврат по чеку продажи'),
        ('COMMAND_PROCESSING_BYCARD','Платеж по карте'),
        ('COMMAND_PROCESSING_BYNUMBER','Платеж по номеру'),
        ('COMMAND_PROCESSING_BIND','Привязка номера к карте'),
        ('COMMAND_PROCESSING_UNBIND','Отвязка номера'),
        ('COMMAND_SELECTBYNAME','Подбор по наименованию'),
        ('COMMAND_SELECTBYCODE','Подбор по коду'),
        ('COMMAND_TESTBYCODE','Просмотр информации о товаре (подбор по коду)'),
        ('COMMAND_SETWORKDATE','Уставить рабочую дату'),
        ('COMMAND_CASHDRAWERSUM','Просмотр суммы в денежном ящике'),
        ('COMMAND_PUTOUT','Отложить чек'),
        ('COMMAND_REVEAL','Восстановить чек'),
        ('COMMAND_UNCLOSED_DOCUMENT','Незавершенный документ'),
        ]
        
listOlderCommands = [
        ('COMMAND_ADDMONEYPOSITION', 'Добавление денежной позиции (внесение/изъятие)'),
        ]

def insertCommandInDB():
    for command in listcommand[:]:
        commandname = command[0]
        commanddescr = command[1]
        cursor.execute("SELECT * FROM command WHERE commandname = %s", (commandname))
        comdb = cursor.fetchone()       
        if not comdb:
            cursor.execute("INSERT INTO command (commandname, description) VALUES (%s, %s);", (commandname, commanddescr))  # Insert in table 'command' a new command   
            cursor.execute("SELECT commandcode from command WHERE commandname = %s", (commandname))
            newcommand = cursor.fetchone()      
            commandcode = newcommand[0]                                                                                     # Select id new command
            cursor.execute("INSERT INTO cmaction (cmactionname, commandcode) VALUES (%s, %s);", (commanddescr, commandcode))# Insert new cmaction from new command

insertCommandInDB()


    
denyForCashier = [
        'COMMAND_SALE',
        'COMMAND_BACK',
        'COMMAND_QUANT',
        'COMMAND_PRICE',
        'COMMAND_STORNOSELECT',
        'COMMAND_STORNOALL',
        'COMMAND_OPERATION',
        'COMMAND_MONEYOP',
        'COMMAND_ADDMONEYPOSITION',
        'COMMAND_CDTEST',
        'COMMAND_DRAWERTEST',
        'COMMAND_KBTEST',
        'COMMAND_KKMTEST',
        'COMMAND_VERIFYTOTAL',
        'COMMAND_VALUT_OPERATIONEXT',
        'COMMAND_INVENTORY',
        'COMMAND_INVENTORYCLOSE',
        'COMMAND_DOCCANCEL',
        'COMMAND_SETWORKDATE',
        'COMMAND_CASHDRAWERSUM',
        'COMMAND_PUTOUT',
        'COMMAND_REVEAL',
        'COMMAND_UNCLOSED_DOCUMENT',
        ]
listForAdmin = [
        'COMMAND_STORNOSELECT',
        'COMMAND_STORNOALL',
        ]
listForOperator = [
        'COMMAND_OPERATION',
        ]

#*******************************************************ADD RIGHTS******************************************
cursor.execute("delete from mol")
cursor.execute("delete from roleuser")
cursor.execute("delete from role;")
cursor.execute("delete from rolecmaction;")
cursor.execute("delete from rolerelation;")



id_operator = 1
cursor.execute("INSERT INTO role (rolecode, rolename) VALUES (%s, 'Оператор-кассир');", (id_operator))
cursor.execute("INSERT INTO mol (code, login, name, password) VALUES (%s, %s, 'Оператор-кассир', %s);", (id_operator, id_operator, id_operator, ))
cursor.execute("INSERT INTO roleuser (usercode, rolecode, rule) VALUES (%s, %s, 1);", (id_operator, id_operator, ))

id_admin = 2
cursor.execute("INSERT INTO role (rolecode, rolename) VALUES (%s, 'Администратор торгового зала');", (id_admin))
cursor.execute("INSERT INTO mol (code, login, name, password) VALUES (%s, %s, 'Администратор торгового зала', %s);", (id_admin, id_admin, id_admin, ))
cursor.execute("INSERT INTO roleuser (usercode, rolecode, rule) VALUES (%s, %s, 1);", (id_admin, id_admin, ))

id_cashier = 3
cursor.execute("INSERT INTO role (rolecode, rolename) VALUES (%s, 'Кассир');", (id_cashier))
cursor.execute("INSERT INTO mol (code, login, name, password) VALUES (%s, %s, 'Кассир', %s);", (id_cashier, id_cashier, id_cashier, ))
cursor.execute("INSERT INTO roleuser (usercode, rolecode, rule) VALUES (%s, %s, 1);", (id_cashier, id_cashier, ))
cursor.execute("INSERT INTO rolerelation (primaryrole, secondaryrole, rule) VALUES (%s, %s, 1);", (id_operator, id_cashier))

id_root = 4
cursor.execute("INSERT INTO role (rolecode, rolename) VALUES (%s, 'Полный доступ');", (id_root))
cursor.execute("INSERT INTO mol (code, login, name, password) VALUES (%s, %s, 'Полный доступ', %s);", (id_root, id_root, id_root, ))
cursor.execute("INSERT INTO roleuser (usercode, rolecode, rule) VALUES (%s, %s, 1);", (id_root, id_root, ))

cursor.execute("SELECT cmactioncode, commandname FROM cmaction a LEFT JOIN command c ON a.commandcode = c.commandcode order by 1;;")
cmactions = cursor.fetchall();
for cmaction in cmactions:
    #********************ROOT
    cursor.execute("INSERT INTO rolecmaction (rolecode, cmactioncode, rule, documenttype) VALUES (%s, %s, 1, 255);", (id_root, cmaction[0]))
    #********************CASHIER
    if cmaction[1] not in denyForCashier:
        cursor.execute("INSERT INTO rolecmaction (rolecode, cmactioncode, rule, documenttype) VALUES (%s, %s, 1, 255);", (id_cashier, cmaction[0]))        
    #********************ADMIN
    if cmaction[1] in listForAdmin:
        cursor.execute("INSERT INTO rolecmaction (rolecode, cmactioncode, rule, documenttype) VALUES (%s, %s, 1, 255);", (id_admin, cmaction[0]))
    
    #********************OPERATOR
    if cmaction[1] in listForOperator:
        cursor.execute("INSERT INTO rolecmaction (rolecode, cmactioncode, rule, documenttype) VALUES (%s, %s, 1, 255);", (id_operator, cmaction[0]))


listCashierMoneyIn = [
        'COMMAND_ADDMONEYPOSITION',
        'COMMAND_STORNOSELECT',
        'COMMAND_STORNOALL',
        ]
for monIn in listCashierMoneyIn:
    cursor.execute("SELECT * FROM cmaction c, command com WHERE c.commandcode=com.commandcode AND com.commandname = %s;", (monIn))
    moneyposition = cursor.fetchone();
    cursor.execute("INSERT INTO rolecmaction (rolecode, cmactioncode, rule, documenttype) VALUES (%s, %s, 1, 3);", (id_cashier, moneyposition[0]))

cursor.execute("SELECT * FROM cmaction c, command com ,  actionparameter a WHERE c.commandcode=com.commandcode AND a.cmactioncode = c.cmactioncode AND a.parametervalue = 'chtMoneyIn' AND com.commandname = 'COMMAND_MONEYOP';")
moneyop = cursor.fetchone();
cursor.execute("INSERT INTO rolecmaction (rolecode, cmactioncode, rule, documenttype) VALUES (%s, %s, 1, 0);", (id_cashier, moneyop[0]))

print('New roles are created.')

#*******************************************************ADD KBKEYS******************************************
context = (
            'browse',               #
            'connectkkm',           #
            'documentinventory',
            'documentoperation',
            'inventoryoperation',
            'keyboardtest',         #
            'kkmtest',              #
            'mainmenu',
            'moneyoperation',
            'operation',            #
            'processingdialog',
            'receiptchange',
            'receiptforming',   
            'receiptpayment',   
            'receiptview',
            'report',               #
            'shiftclose',
            'simplemenu',
            'view'
            )                       



listAllCommand = [
    ('COMMAND_ADDMONEYPOSITION',('moneyoperation',)),
    ('COMMAND_ADDPAYMENTPOSITION', ('receiptpayment',)),
    ('COMMAND_APPLY',('receiptforming', 'documentinventory',)),
    ('COMMAND_BACK',('documentoperation', 'receiptforming',)),
    ('COMMAND_BACKBYSALE',('receiptforming',)), 
    ('COMMAND_BCODE',('documentinventory', 'receiptforming',)),
    ('COMMAND_BCODETEST',('receiptforming', 'documentinventory',)),
    ('COMMAND_BCODETESTBYNAME',('documentinventory', 'receiptforming',)),
    ('COMMAND_BUTTON',('receiptpayment',)),
    ('COMMAND_CALC',('receiptpayment', 'receiptforming', 'receiptchange', 'moneyoperation',)),
    ('COMMAND_CARD',('receiptpayment', 'receiptforming', 'receiptchange', )),
    ('COMMAND_CARDDISC',('receiptpayment',)),
    ('COMMAND_CARDINFO',('receiptpayment', 'receiptforming', 'receiptchange',)),
    ('COMMAND_CDTEST',('mainmenu', '',)),
    ('COMMAND_CODE',('documentinventory', 'receiptforming',)),
    ('COMMAND_DEPT',('receiptforming', 'documentinventory',)),
    ('COMMAND_DEPTN',('receiptforming', 'documentinventory',)),
    ('COMMAND_DOCCANCEL',('receiptforming',)),
    ('COMMAND_DOCOPEN',('receiptforming',)),
    ('COMMAND_DOCOPER',('mainmenu',)),
    ('COMMAND_DRAWERTEST',('mainmenu',)),   
    ('COMMAND_EXIT',('view', 'mainmenu', 'receiptforming', 'moneyoperation', 'documentinventory', 'receiptview',)), 
    ('COMMAND_EXTDISC',('receiptpayment',)),    
    ('COMMAND_FIXEDDISC',('receiptpayment',)),
    ('COMMAND_FIXEDDISC_BYCARD',('receiptpayment',)),
    ('COMMAND_INVENTORY',('mainmenu',)),
    ('COMMAND_INVENTORYCLOSE',('mainmenu',)),
    ('COMMAND_INVENTORYDOCOPER',('mainmenu',)),
    ('COMMAND_KBTEST',('mainmenu',)),
    ('COMMAND_KKMTEST',('mainmenu',)),  
    ('COMMAND_LOGIN',('mainmenu', 'receiptforming',)),
    ('COMMAND_MACRO',('documentinventory', 'receiptforming', 'receiptview',)),  
    
    ('COMMAND_MANDISC_DOC_ABS',('receiptpayment',)),
    ('COMMAND_MANDISC_DOC_PERC',('receiptpayment',)),
    ('COMMAND_MANDISC_POS_PERC',('receiptpayment',)),   
    ('COMMAND_MANDISC_DOC_ABS_NEG',('receiptpayment',)),    
    ('COMMAND_MANDISC_DOC_PERC_NEG',('receiptpayment',)),
    ('COMMAND_MANDISC_POS_ABS',('receiptpayment',)),
    ('COMMAND_MANDISC_POS_ABS_NEG',('receiptpayment',)),    
    ('COMMAND_MANDISC_POS_PERC_NEG',('receiptpayment',)),
    
    ('COMMAND_MENU',('documentinventory', 'moneyoperation', 'receiptchange', 'receiptforming', 'receiptpayment', 'receiptview', 'simplemenu',)),
    ('COMMAND_MENUEXIT',('simplemenu', )),
    ('COMMAND_MONEYOP',('mainmenu',)),      
    ('COMMAND_ONEBACK',('receiptforming',)),
    ('COMMAND_OPENDRAWER',('receiptpayment', 'receiptforming', 'receiptchange', 'moneyoperation',)),
    ('COMMAND_OPERATION',('documentinventory', 'receiptforming', 'receiptview', 'mainmenu', 'shiftclose',)),            
    ('COMMAND_PACKING',('receiptforming',)),    
    ('COMMAND_PRICE',('receiptforming',)),
    ('COMMAND_PRINTCOPY',('documentoperation', 'receiptview', 'receiptpayment', 'receiptforming', 'receiptchange', 'inventoryoperation', )),
    ('COMMAND_PRINTGOODSCH',('documentoperation', 'receiptview', 'receiptpayment', 'receiptforming', 'receiptchange')),
    ('COMMAND_PROCESSING_BIND',('processingdialog', 'receiptforming',)),    
    ('COMMAND_PROCESSING_UNBIND',('processingdialog', 'receiptforming',)),
    ('COMMAND_PROCESSING_BYCARD',('processingdialog', 'receiptforming',)),
    ('COMMAND_PROCESSING_BYNUMBER',('processingdialog', 'receiptforming',)),        
    ('COMMAND_REPEAT',('documentinventory', 'receiptforming',)),    
    ('COMMAND_QUANT',('receiptforming', 'documentinventory',)),
    ('COMMAND_SALE',('receiptforming',)),
    ('COMMAND_SCALES',('documentinventory', 'receiptforming',)),
    ('COMMAND_SELECTBYCODE',('receiptforming',)),
    ('COMMAND_SELECTBYNAME',('documentinventory', 'receiptforming',)),
    ('COMMAND_SELECTPRICE',('receiptforming',)),    
    ('COMMAND_SELECTTMC',('receiptforming', 'documentinventory', 'receiptview',)),
    ('COMMAND_SETWORKDATE',('mainmenu',)),  
    ('COMMAND_SHIFTCLOSE',('mainmenu',)),
    ('COMMAND_SHIFTCLOSE_INREG',('shiftclose',)),       
    ('COMMAND_SUBTOTAL',('receiptforming', )),
    ('COMMAND_STORNOALL',('receiptpayment', 'receiptforming', 'receiptchange', 'moneyoperation', 'documentinventory',)),
    ('COMMAND_STORNOLAST',('moneyoperation', 'receiptpayment',)),
    ('COMMAND_STORNOSELECT',('receiptpayment', 'receiptforming', 'receiptchange', 'moneyoperation', 'documentinventory',)),
    ('COMMAND_TERMINAL',('mainmenu',)),
    ('COMMAND_TESTBYCODE',('receiptforming',)),     
    ('COMMAND_TOTAL',('receiptpayment', 'receiptchange', 'moneyoperation', 'documentinventory',)),
    ('COMMAND_VALUT',('mainmenu', 'receiptchange', 'receiptforming', 'receiptpayment', 'moneyoperation',)), 
    ('COMMAND_VALUTDETECTOR',('moneyoperation', 'receiptchange', 'receiptforming', 'receiptpayment',)),
    ('COMMAND_VALUT_OPERATIONEXT',('mainmenu',)),
    ('COMMAND_VERIFYTOTAL',('mainmenu', 'shiftclose',)),
    ('COMMAND_VIEW',('inventoryoperation', 'documentoperation',)),
    ]


cursor.execute("delete from kbkey1 where context!=\"\";")
cursor.execute("SELECT * FROM kbkey k, command com, cmaction c WHERE k.cmactioncode = c.cmactioncode AND com.commandcode = c.commandcode;")
kbkey = cursor.fetchall();
for key in kbkey:
    for allCom in listAllCommand:
        if key[5]== allCom[0]:
            for cont in allCom[1]:          
                cursor.execute("insert into kbkey(keycode, cmactioncode, keyvalue, context) VALUES (%s, %s, %s, %s);", (key[0], key[1], key[2], cont))      

# в moneyoperation на кнопку ENTER ставим действие с командой COMMAND_ADDMONEYPOSITION
cursor.execute("select * from cmaction c, command com where c.commandcode = com.commandcode AND com.commandname = 'COMMAND_ADDMONEYPOSITION';")                     
cmactionaddmon = cursor.fetchone();
cursor.execute("insert into kbkey(keycode, cmactioncode, keyvalue, context) VALUES (13, %s, 'Enter', 'moneyoperation');", (cmactionaddmon[0]))                      

# на действие с командой COMMAND_SUBTOTAL ставим такую же кнопку как и на COMMAND_TOTAL
cursor.execute("SELECT * FROM kbkey k, cmaction c, command com WHERE k.cmactioncode = c.cmactioncode AND c.commandcode = com.commandcode AND com.commandname = 'COMMAND_TOTAL';")
total = cursor.fetchone();
cursor.execute("SELECT * FROM  cmaction c, command com WHERE  c.commandcode = com.commandcode AND com.commandname = 'COMMAND_SUBTOTAL';")
subtotal = cursor.fetchone();
cursor.execute("insert into kbkey(keycode, cmactioncode, keyvalue, context) VALUES (%s, %s, %s, 'receiptforming');", (total[0], subtotal[0] ,total[2]))

# в moneyoperation на кнопку ENTER ставим действие с командой COMMAND_ADDMONEYPOSITION
cursor.execute("select * from cmaction c, command com where c.commandcode = com.commandcode AND com.commandname = 'COMMAND_BCODE';")                        
bcode = cursor.fetchone();
cursor.execute("insert into kbkey(keycode, cmactioncode, keyvalue, context) VALUES (13, %s, 'Enter', 'receiptforming');", (bcode[0]))                       

# в receiptpayment на кнопку ENTER ставим действие с командой COMMAND_ADDPAYMENTPOSITION
cursor.execute("select * from cmaction c, command com where c.commandcode = com.commandcode AND com.commandname = 'COMMAND_ADDPAYMENTPOSITION';")                       
payment = cursor.fetchone();
cursor.execute("insert into kbkey(keycode, cmactioncode, keyvalue, context) VALUES (13, %s, 'Enter', 'receiptpayment');", (payment[0]))

print('New keys are created.')


































